package xaero.map.teleport;

package ..deTemp.1747404749601;

import net.minecraft.ChatFormatting;
import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.screens.Screen;
import net.minecraft.client.resources.language.I18n;
import net.minecraft.network.chat.Component;
import net.minecraft.network.chat.MutableComponent;
import net.minecraft.resources.ResourceKey;
import net.minecraft.world.level.Level;
import xaero.map.WorldMap;
import xaero.map.world.MapConnectionNode;
import xaero.map.world.MapDimension;
import xaero.map.world.MapWorld;

public class MapTeleporter {
  public void teleport(Screen screen, MapWorld mapWorld, int x, int y, int z, ResourceKey<Level> d) {
    Minecraft.m_91087_().m_91152_(null);
    if ((Minecraft.m_91087_()).f_91072_.m_105205_()) {
      MapDimension destinationDim = mapWorld.getDimension((d != null) ? d : (Minecraft.m_91087_()).f_91073_.m_46472_());
      MapConnectionNode playerMapKey = mapWorld.getPlayerMapKey();
      if (playerMapKey == null) {
        MutableComponent messageComponent = Component.m_237113_(I18n.m_118938_("gui.xaero_wm_teleport_never_confirmed", new Object[0]));
        messageComponent.m_6270_(messageComponent.m_7383_().m_131140_(ChatFormatting.RED));
        (Minecraft.m_91087_()).f_91065_.m_93076_().m_93785_((Component)messageComponent);
        return;
      } 
      MapConnectionNode destinationMapKey = (destinationDim == null) ? null : destinationDim.getSelectedMapKeyUnsynced();
      if (!mapWorld.getMapConnections().isConnected(playerMapKey, destinationMapKey)) {
        MutableComponent messageComponent = Component.m_237113_(I18n.m_118938_("gui.xaero_wm_teleport_not_connected", new Object[0]));
        messageComponent.m_6270_(messageComponent.m_7383_().m_131140_(ChatFormatting.RED));
        (Minecraft.m_91087_()).f_91065_.m_93076_().m_93785_((Component)messageComponent);
        return;
      } 
    } 
    String tpCommand = (d == null) ? mapWorld.getTeleportCommandFormat() : mapWorld.getDimensionTeleportCommandFormat();
    String yString = (y == 32767) ? "~" : (WorldMap.settings.partialYTeleportation ? ("" + y + 0.5D) : ("" + y));
    tpCommand = tpCommand.replace("{x}", "" + x).replace("{y}", yString).replace("{z}", "" + z);
    if (d != null)
      tpCommand = tpCommand.replace("{d}", d.m_135782_().toString()); 
    Minecraft mc = Minecraft.m_91087_();
    if (tpCommand.startsWith("/")) {
      tpCommand = tpCommand.substring(1);
      if (!mc.f_91074_.f_108617_.m_246979_(tpCommand))
        mc.f_91074_.f_108617_.m_246623_(tpCommand); 
    } else {
      mc.f_91074_.f_108617_.m_246175_(tpCommand);
    } 
    mapWorld.setCustomDimensionId(null);
    mapWorld.getMapProcessor().checkForWorldUpdate();
  }
}
